using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Web;
using System.Net;

namespace JadamPrograms.TeamServer
{
	/// <summary>
	/// Summary description for NewProjServ.
	/// </summary>
	public class NewTeamServ : System.Windows.Forms.Form
	{
    private System.Windows.Forms.GroupBox gbFTP;
    public System.Windows.Forms.TextBox txtUser;
    private System.Windows.Forms.Label lblServer;
    private System.Windows.Forms.Label lblUser;
    public System.Windows.Forms.TextBox txtServer;
    private System.Windows.Forms.Label lblPass;
    private System.Windows.Forms.Label lblPort;
    public System.Windows.Forms.TextBox txtPass;
    public UtilityLibrary.WinControls.NumericTextBox txtPort;
    private System.Windows.Forms.Label lblServerPl;
    private System.Windows.Forms.Label lblUserPl;
    private System.Windows.Forms.Label lblPassPl;
    private System.Windows.Forms.Label lblPortPl;
    private System.Windows.Forms.GroupBox gbTeamServ;
    private System.Windows.Forms.Label lblTSName;
    private System.Windows.Forms.GroupBox gbServer;
    private System.Windows.Forms.Label lblSState;
    private System.Windows.Forms.Label lblSSValue;
    private System.Windows.Forms.Button btnGetState;
    private System.Windows.Forms.Button btnInstallSoftware;
    private System.Windows.Forms.Button btnCancel;
    private System.Windows.Forms.Button btnSave;
    public System.Windows.Forms.TextBox txtTSName;
    private System.Windows.Forms.Label lblHomelapPl;
    private System.Windows.Forms.Label lblHomelap;
    private System.Windows.Forms.Label lblTSNamePl;
    public System.Windows.Forms.TextBox txtHomelap;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

    public string TSName = ""; 

		public NewTeamServ()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.txtUser = new System.Windows.Forms.TextBox();
      this.gbFTP = new System.Windows.Forms.GroupBox();
      this.txtPort = new UtilityLibrary.WinControls.NumericTextBox();
      this.lblPass = new System.Windows.Forms.Label();
      this.lblPort = new System.Windows.Forms.Label();
      this.txtPass = new System.Windows.Forms.TextBox();
      this.lblPassPl = new System.Windows.Forms.Label();
      this.lblPortPl = new System.Windows.Forms.Label();
      this.txtServer = new System.Windows.Forms.TextBox();
      this.lblUserPl = new System.Windows.Forms.Label();
      this.lblUser = new System.Windows.Forms.Label();
      this.lblServerPl = new System.Windows.Forms.Label();
      this.lblServer = new System.Windows.Forms.Label();
      this.gbTeamServ = new System.Windows.Forms.GroupBox();
      this.txtTSName = new System.Windows.Forms.TextBox();
      this.lblHomelapPl = new System.Windows.Forms.Label();
      this.lblHomelap = new System.Windows.Forms.Label();
      this.lblTSNamePl = new System.Windows.Forms.Label();
      this.lblTSName = new System.Windows.Forms.Label();
      this.txtHomelap = new System.Windows.Forms.TextBox();
      this.gbServer = new System.Windows.Forms.GroupBox();
      this.btnGetState = new System.Windows.Forms.Button();
      this.lblSSValue = new System.Windows.Forms.Label();
      this.lblSState = new System.Windows.Forms.Label();
      this.btnInstallSoftware = new System.Windows.Forms.Button();
      this.btnCancel = new System.Windows.Forms.Button();
      this.btnSave = new System.Windows.Forms.Button();
      this.gbFTP.SuspendLayout();
      this.gbTeamServ.SuspendLayout();
      this.gbServer.SuspendLayout();
      this.SuspendLayout();
      // 
      // txtUser
      // 
      this.txtUser.Location = new System.Drawing.Point(96, 56);
      this.txtUser.Name = "txtUser";
      this.txtUser.Size = new System.Drawing.Size(168, 20);
      this.txtUser.TabIndex = 0;
      this.txtUser.Text = "";
      // 
      // gbFTP
      // 
      this.gbFTP.Controls.Add(this.txtPort);
      this.gbFTP.Controls.Add(this.lblPass);
      this.gbFTP.Controls.Add(this.lblPort);
      this.gbFTP.Controls.Add(this.txtPass);
      this.gbFTP.Controls.Add(this.lblPassPl);
      this.gbFTP.Controls.Add(this.lblPortPl);
      this.gbFTP.Controls.Add(this.txtServer);
      this.gbFTP.Controls.Add(this.lblUserPl);
      this.gbFTP.Controls.Add(this.lblUser);
      this.gbFTP.Controls.Add(this.lblServerPl);
      this.gbFTP.Controls.Add(this.lblServer);
      this.gbFTP.Controls.Add(this.txtUser);
      this.gbFTP.Location = new System.Drawing.Point(8, 104);
      this.gbFTP.Name = "gbFTP";
      this.gbFTP.Size = new System.Drawing.Size(512, 152);
      this.gbFTP.TabIndex = 1;
      this.gbFTP.TabStop = false;
      this.gbFTP.Text = "FTP Server adatai";
      // 
      // txtPort
      // 
      this.txtPort.Location = new System.Drawing.Point(96, 120);
      this.txtPort.Name = "txtPort";
      this.txtPort.SetRange = new System.Drawing.Size(0, 10000);
      this.txtPort.Size = new System.Drawing.Size(168, 20);
      this.txtPort.TabIndex = 2;
      this.txtPort.Text = "21";
      // 
      // lblPass
      // 
      this.lblPass.Location = new System.Drawing.Point(8, 88);
      this.lblPass.Name = "lblPass";
      this.lblPass.Size = new System.Drawing.Size(80, 23);
      this.lblPass.TabIndex = 1;
      this.lblPass.Text = "Jelsz:";
      // 
      // lblPort
      // 
      this.lblPort.Location = new System.Drawing.Point(8, 120);
      this.lblPort.Name = "lblPort";
      this.lblPort.Size = new System.Drawing.Size(80, 23);
      this.lblPort.TabIndex = 1;
      this.lblPort.Text = "Port:";
      // 
      // txtPass
      // 
      this.txtPass.Location = new System.Drawing.Point(96, 88);
      this.txtPass.Name = "txtPass";
      this.txtPass.PasswordChar = '*';
      this.txtPass.Size = new System.Drawing.Size(168, 20);
      this.txtPass.TabIndex = 0;
      this.txtPass.Text = "";
      // 
      // lblPassPl
      // 
      this.lblPassPl.Location = new System.Drawing.Point(272, 88);
      this.lblPassPl.Name = "lblPassPl";
      this.lblPassPl.Size = new System.Drawing.Size(232, 23);
      this.lblPassPl.TabIndex = 1;
      this.lblPassPl.Text = "A bejelentkezshez.";
      // 
      // lblPortPl
      // 
      this.lblPortPl.Location = new System.Drawing.Point(272, 120);
      this.lblPortPl.Name = "lblPortPl";
      this.lblPortPl.Size = new System.Drawing.Size(232, 23);
      this.lblPortPl.TabIndex = 1;
      this.lblPortPl.Text = "Legtbbszr a 21-es portra van szksg.";
      // 
      // txtServer
      // 
      this.txtServer.Location = new System.Drawing.Point(96, 24);
      this.txtServer.Name = "txtServer";
      this.txtServer.Size = new System.Drawing.Size(168, 20);
      this.txtServer.TabIndex = 0;
      this.txtServer.Text = "";
      // 
      // lblUserPl
      // 
      this.lblUserPl.Location = new System.Drawing.Point(272, 56);
      this.lblUserPl.Name = "lblUserPl";
      this.lblUserPl.Size = new System.Drawing.Size(232, 23);
      this.lblUserPl.TabIndex = 1;
      this.lblUserPl.Text = "A bejelentkezshez.";
      // 
      // lblUser
      // 
      this.lblUser.Location = new System.Drawing.Point(8, 56);
      this.lblUser.Name = "lblUser";
      this.lblUser.Size = new System.Drawing.Size(80, 23);
      this.lblUser.TabIndex = 1;
      this.lblUser.Text = "User nv:";
      // 
      // lblServerPl
      // 
      this.lblServerPl.Location = new System.Drawing.Point(272, 24);
      this.lblServerPl.Name = "lblServerPl";
      this.lblServerPl.Size = new System.Drawing.Size(232, 23);
      this.lblServerPl.TabIndex = 1;
      this.lblServerPl.Text = "PL.: ftp.extra.hu";
      // 
      // lblServer
      // 
      this.lblServer.Location = new System.Drawing.Point(8, 24);
      this.lblServer.Name = "lblServer";
      this.lblServer.Size = new System.Drawing.Size(80, 23);
      this.lblServer.TabIndex = 1;
      this.lblServer.Text = "FTP Server:";
      // 
      // gbTeamServ
      // 
      this.gbTeamServ.Controls.Add(this.txtTSName);
      this.gbTeamServ.Controls.Add(this.lblHomelapPl);
      this.gbTeamServ.Controls.Add(this.lblHomelap);
      this.gbTeamServ.Controls.Add(this.lblTSNamePl);
      this.gbTeamServ.Controls.Add(this.lblTSName);
      this.gbTeamServ.Controls.Add(this.txtHomelap);
      this.gbTeamServ.Location = new System.Drawing.Point(8, 8);
      this.gbTeamServ.Name = "gbTeamServ";
      this.gbTeamServ.Size = new System.Drawing.Size(512, 88);
      this.gbTeamServ.TabIndex = 2;
      this.gbTeamServ.TabStop = false;
      this.gbTeamServ.Text = "Team Server adatai";
      // 
      // txtTSName
      // 
      this.txtTSName.Location = new System.Drawing.Point(96, 24);
      this.txtTSName.Name = "txtTSName";
      this.txtTSName.Size = new System.Drawing.Size(168, 20);
      this.txtTSName.TabIndex = 0;
      this.txtTSName.Text = "";
      // 
      // lblHomelapPl
      // 
      this.lblHomelapPl.Location = new System.Drawing.Point(272, 56);
      this.lblHomelapPl.Name = "lblHomelapPl";
      this.lblHomelapPl.Size = new System.Drawing.Size(232, 23);
      this.lblHomelapPl.TabIndex = 1;
      this.lblHomelapPl.Text = "A szerverhez tartoz homelap cme.";
      // 
      // lblHomelap
      // 
      this.lblHomelap.Location = new System.Drawing.Point(8, 56);
      this.lblHomelap.Name = "lblHomelap";
      this.lblHomelap.Size = new System.Drawing.Size(80, 23);
      this.lblHomelap.TabIndex = 1;
      this.lblHomelap.Text = "Homelap cm:";
      // 
      // lblTSNamePl
      // 
      this.lblTSNamePl.Location = new System.Drawing.Point(272, 24);
      this.lblTSNamePl.Name = "lblTSNamePl";
      this.lblTSNamePl.Size = new System.Drawing.Size(232, 23);
      this.lblTSNamePl.TabIndex = 1;
      this.lblTSNamePl.Text = "PL.: JAP Team Server";
      // 
      // lblTSName
      // 
      this.lblTSName.Location = new System.Drawing.Point(8, 24);
      this.lblTSName.Name = "lblTSName";
      this.lblTSName.Size = new System.Drawing.Size(80, 23);
      this.lblTSName.TabIndex = 1;
      this.lblTSName.Text = "Nv:";
      // 
      // txtHomelap
      // 
      this.txtHomelap.Location = new System.Drawing.Point(96, 56);
      this.txtHomelap.Name = "txtHomelap";
      this.txtHomelap.Size = new System.Drawing.Size(168, 20);
      this.txtHomelap.TabIndex = 0;
      this.txtHomelap.Text = "";
      // 
      // gbServer
      // 
      this.gbServer.Controls.Add(this.btnGetState);
      this.gbServer.Controls.Add(this.lblSSValue);
      this.gbServer.Controls.Add(this.lblSState);
      this.gbServer.Controls.Add(this.btnInstallSoftware);
      this.gbServer.Location = new System.Drawing.Point(8, 264);
      this.gbServer.Name = "gbServer";
      this.gbServer.Size = new System.Drawing.Size(512, 88);
      this.gbServer.TabIndex = 3;
      this.gbServer.TabStop = false;
      this.gbServer.Text = "Team Server Software";
      // 
      // btnGetState
      // 
      this.btnGetState.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnGetState.Location = new System.Drawing.Point(408, 24);
      this.btnGetState.Name = "btnGetState";
      this.btnGetState.Size = new System.Drawing.Size(96, 24);
      this.btnGetState.TabIndex = 2;
      this.btnGetState.Text = "Vizsglat";
      this.btnGetState.Click += new System.EventHandler(this.btnGetState_Click);
      // 
      // lblSSValue
      // 
      this.lblSSValue.Location = new System.Drawing.Point(112, 24);
      this.lblSSValue.Name = "lblSSValue";
      this.lblSSValue.Size = new System.Drawing.Size(288, 23);
      this.lblSSValue.TabIndex = 1;
      this.lblSSValue.Text = "Kattintson a vizsglra.";
      // 
      // lblSState
      // 
      this.lblSState.Location = new System.Drawing.Point(8, 24);
      this.lblSState.Name = "lblSState";
      this.lblSState.Size = new System.Drawing.Size(96, 23);
      this.lblSState.TabIndex = 0;
      this.lblSState.Text = "A Server llapota:";
      // 
      // btnInstallSoftware
      // 
      this.btnInstallSoftware.Enabled = false;
      this.btnInstallSoftware.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnInstallSoftware.Location = new System.Drawing.Point(8, 56);
      this.btnInstallSoftware.Name = "btnInstallSoftware";
      this.btnInstallSoftware.Size = new System.Drawing.Size(496, 24);
      this.btnInstallSoftware.TabIndex = 2;
      this.btnInstallSoftware.Text = "Software teleptse";
      this.btnInstallSoftware.Click += new System.EventHandler(this.btnInstallSoftware_Click);
      // 
      // btnCancel
      // 
      this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnCancel.Location = new System.Drawing.Point(424, 360);
      this.btnCancel.Name = "btnCancel";
      this.btnCancel.Size = new System.Drawing.Size(96, 24);
      this.btnCancel.TabIndex = 2;
      this.btnCancel.Text = "Mgsem";
      this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
      // 
      // btnSave
      // 
      this.btnSave.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnSave.Location = new System.Drawing.Point(320, 360);
      this.btnSave.Name = "btnSave";
      this.btnSave.Size = new System.Drawing.Size(96, 24);
      this.btnSave.TabIndex = 2;
      this.btnSave.Text = "Ments";
      this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
      // 
      // NewTeamServ
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(220)), ((System.Byte)(234)), ((System.Byte)(245)));
      this.ClientSize = new System.Drawing.Size(528, 390);
      this.ControlBox = false;
      this.Controls.Add(this.gbServer);
      this.Controls.Add(this.gbTeamServ);
      this.Controls.Add(this.gbFTP);
      this.Controls.Add(this.btnCancel);
      this.Controls.Add(this.btnSave);
      this.Name = "NewTeamServ";
      this.Text = "j Team Server";
      this.gbFTP.ResumeLayout(false);
      this.gbTeamServ.ResumeLayout(false);
      this.gbServer.ResumeLayout(false);
      this.ResumeLayout(false);

    }
		#endregion

    private void btnSave_Click(object sender, System.EventArgs e)
    {
      if(this.txtTSName.Text  != "" &&
         this.txtHomelap.Text != "" &&
         this.txtServer.Text  != "" &&
         this.txtUser.Text    != "" &&
         this.txtPass.Text    != "" &&
         this.txtPort.Text    != "")
      {
        try
        {      
          FileStream fs = new FileStream(Environment.CurrentDirectory + 
                                         "\\TeamServers\\" + 
                                         this.txtTSName.Text + ".jts",
                                         FileMode.Create);
                                       
          StreamWriter sw = new StreamWriter(fs);
          sw.WriteLine(this.txtTSName.Text);
          sw.WriteLine(this.txtHomelap.Text);
          sw.WriteLine(this.txtServer.Text);
          sw.WriteLine(this.txtUser.Text);
          sw.WriteLine(this.txtPass.Text);        
          sw.WriteLine(Convert.ToInt32(this.txtPort.Text)); 
          sw.Close();
          fs.Close();
          TSName = this.txtTSName.Text;
          this.DialogResult = DialogResult.OK;
          this.Close();
        }
        catch
        {
          MessageBox.Show("Ments sikertelen!");
        }
      }
      else
      {
        MessageBox.Show("A mentshez tltse ki a formot!","Hiba");
      }
    }

    private void btnCancel_Click(object sender, System.EventArgs e)
    {
      this.DialogResult = DialogResult.Cancel;
      this.Close();
    }
    
    #region GetDataFromServer
    
    //
    //PHP-vel adotak kr a szervertol.
    //
    public string GetDataFromServer(string QueryString)
    {
      try
      {
        WebRequest reqest = WebRequest.Create(QueryString);
        WebResponse response = reqest.GetResponse();
        StreamReader sr = new StreamReader(response.GetResponseStream(),System.Text.Encoding.UTF8);
        string read = sr.ReadToEnd();
        reqest.Abort();
        response.Close();
        sr.Close();
        return read;
      }
      catch(System.Exception e)
      {
        return "";
      }
    }
    #endregion

    private void btnGetState_Click(object sender, System.EventArgs e)
    {
      if(this.txtTSName.Text  != "" &&
         this.txtHomelap.Text != "" &&
         this.txtServer.Text  != "" &&
         this.txtUser.Text    != "" &&
         this.txtPass.Text    != "" &&
         this.txtPort.Text    != "")
      {
        if(GetDataFromServer(this.txtHomelap.Text + "/teamserv.php") != "")
        {
          this.lblSSValue.Text = "A JAP Team Server Software teleptve van.";
          this.btnInstallSoftware.Enabled = false;
        }
        else
        {
          this.lblSSValue.Text = "A JAP Team Server Software nincs teleptve.";
          this.btnInstallSoftware.Enabled = true;
        } 
      }
      else
      {
        MessageBox.Show("A vizsglathoz tltse ki a formot!","Hiba");
      }
    }

    private void btnInstallSoftware_Click(object sender, System.EventArgs e)
    {
      SoftwareInstal si = new SoftwareInstal();
      si.server     = this.txtServer.Text;
      si.user       = this.txtUser.Text;
      si.pass       = this.txtPass.Text;
      si.port       = Convert.ToInt32(this.txtPort.Text);
      si.serverpath = this.txtHomelap.Text;
      si.ShowDialog();
    }
	}
}
