using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace JadamPrograms.TeamServer.Dialogs
{
	/// <summary>
	/// Summary description for Settings.
	/// </summary>
	public class Settings : System.Windows.Forms.Form
	{
    private System.Windows.Forms.GroupBox gbUsers;
    private System.Windows.Forms.ListBox lbUsers;
    private System.Windows.Forms.Panel pnlUserInfo;
    private System.Windows.Forms.Button btnNewUser;
    private System.Windows.Forms.Label label3;
    private System.Windows.Forms.GroupBox gbOther;
    private System.Windows.Forms.Label lblUpdateW;
    private System.Windows.Forms.TextBox txtUName;
    private UtilityLibrary.WinControls.NumericTextBox txtUpdateW;
    private System.Windows.Forms.Label lblLogL;
    private System.Windows.Forms.TrackBar tbLogL;
    private System.Windows.Forms.Panel pnlLogL;
    private System.Windows.Forms.CheckBox cbTestMode;
    private System.Windows.Forms.Button btnCancel;
    private System.Windows.Forms.Button btnOK;
    public string serverpath = ""; 
    public string server     = "";
    public string user       = "";		
    public string pass       = "";	
    public int    port       = 21;
    public int UserId        = 0;
    
    string[] Users;
    private System.Windows.Forms.Button btnDelete;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Settings()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.gbUsers = new System.Windows.Forms.GroupBox();
      this.lbUsers = new System.Windows.Forms.ListBox();
      this.pnlUserInfo = new System.Windows.Forms.Panel();
      this.btnNewUser = new System.Windows.Forms.Button();
      this.gbOther = new System.Windows.Forms.GroupBox();
      this.lblUpdateW = new System.Windows.Forms.Label();
      this.txtUpdateW = new UtilityLibrary.WinControls.NumericTextBox();
      this.lblLogL = new System.Windows.Forms.Label();
      this.tbLogL = new System.Windows.Forms.TrackBar();
      this.pnlLogL = new System.Windows.Forms.Panel();
      this.cbTestMode = new System.Windows.Forms.CheckBox();
      this.btnCancel = new System.Windows.Forms.Button();
      this.btnOK = new System.Windows.Forms.Button();
      this.txtUName = new System.Windows.Forms.TextBox();
      this.label3 = new System.Windows.Forms.Label();
      this.btnDelete = new System.Windows.Forms.Button();
      this.gbUsers.SuspendLayout();
      this.pnlUserInfo.SuspendLayout();
      this.gbOther.SuspendLayout();
      ((System.ComponentModel.ISupportInitialize)(this.tbLogL)).BeginInit();
      this.pnlLogL.SuspendLayout();
      this.SuspendLayout();
      // 
      // gbUsers
      // 
      this.gbUsers.Controls.Add(this.btnNewUser);
      this.gbUsers.Controls.Add(this.pnlUserInfo);
      this.gbUsers.Controls.Add(this.lbUsers);
      this.gbUsers.Location = new System.Drawing.Point(8, 8);
      this.gbUsers.Name = "gbUsers";
      this.gbUsers.Size = new System.Drawing.Size(432, 184);
      this.gbUsers.TabIndex = 0;
      this.gbUsers.TabStop = false;
      this.gbUsers.Text = "Felhasznlk";
      // 
      // lbUsers
      // 
      this.lbUsers.Items.AddRange(new object[] {
                                                 ""});
      this.lbUsers.Location = new System.Drawing.Point(8, 24);
      this.lbUsers.Name = "lbUsers";
      this.lbUsers.Size = new System.Drawing.Size(140, 147);
      this.lbUsers.TabIndex = 0;
      this.lbUsers.SelectedIndexChanged += new System.EventHandler(this.lbUsers_SelectedIndexChanged);
      // 
      // pnlUserInfo
      // 
      this.pnlUserInfo.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
      this.pnlUserInfo.Controls.Add(this.label3);
      this.pnlUserInfo.Controls.Add(this.txtUName);
      this.pnlUserInfo.Controls.Add(this.btnDelete);
      this.pnlUserInfo.Location = new System.Drawing.Point(152, 24);
      this.pnlUserInfo.Name = "pnlUserInfo";
      this.pnlUserInfo.Size = new System.Drawing.Size(272, 120);
      this.pnlUserInfo.TabIndex = 1;
      // 
      // btnNewUser
      // 
      this.btnNewUser.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnNewUser.Location = new System.Drawing.Point(152, 148);
      this.btnNewUser.Name = "btnNewUser";
      this.btnNewUser.Size = new System.Drawing.Size(272, 24);
      this.btnNewUser.TabIndex = 2;
      this.btnNewUser.Text = "j  Felhasznl";
      this.btnNewUser.Click += new System.EventHandler(this.btnNewUser_Click);
      // 
      // gbOther
      // 
      this.gbOther.Controls.Add(this.cbTestMode);
      this.gbOther.Controls.Add(this.txtUpdateW);
      this.gbOther.Controls.Add(this.lblUpdateW);
      this.gbOther.Controls.Add(this.lblLogL);
      this.gbOther.Controls.Add(this.pnlLogL);
      this.gbOther.Location = new System.Drawing.Point(8, 196);
      this.gbOther.Name = "gbOther";
      this.gbOther.Size = new System.Drawing.Size(432, 88);
      this.gbOther.TabIndex = 1;
      this.gbOther.TabStop = false;
      this.gbOther.Text = "Egyb";
      // 
      // lblUpdateW
      // 
      this.lblUpdateW.Location = new System.Drawing.Point(8, 24);
      this.lblUpdateW.Name = "lblUpdateW";
      this.lblUpdateW.Size = new System.Drawing.Size(196, 23);
      this.lblUpdateW.TabIndex = 0;
      this.lblUpdateW.Text = "Frists X tizedmsodpercenknt. X:";
      this.lblUpdateW.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
      // 
      // txtUpdateW
      // 
      this.txtUpdateW.Location = new System.Drawing.Point(188, 24);
      this.txtUpdateW.Name = "txtUpdateW";
      this.txtUpdateW.SetRange = new System.Drawing.Size(1000, 60000);
      this.txtUpdateW.Size = new System.Drawing.Size(236, 20);
      this.txtUpdateW.TabIndex = 1;
      this.txtUpdateW.Text = "10000";
      // 
      // lblLogL
      // 
      this.lblLogL.Location = new System.Drawing.Point(8, 56);
      this.lblLogL.Name = "lblLogL";
      this.lblLogL.TabIndex = 0;
      this.lblLogL.Text = "Logolsi szint:";
      this.lblLogL.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
      // 
      // tbLogL
      // 
      this.tbLogL.Dock = System.Windows.Forms.DockStyle.Fill;
      this.tbLogL.Location = new System.Drawing.Point(0, 0);
      this.tbLogL.Maximum = 5;
      this.tbLogL.Name = "tbLogL";
      this.tbLogL.Size = new System.Drawing.Size(176, 24);
      this.tbLogL.TabIndex = 2;
      // 
      // pnlLogL
      // 
      this.pnlLogL.Controls.Add(this.tbLogL);
      this.pnlLogL.Location = new System.Drawing.Point(112, 56);
      this.pnlLogL.Name = "pnlLogL";
      this.pnlLogL.Size = new System.Drawing.Size(176, 24);
      this.pnlLogL.TabIndex = 2;
      // 
      // cbTestMode
      // 
      this.cbTestMode.Location = new System.Drawing.Point(296, 56);
      this.cbTestMode.Name = "cbTestMode";
      this.cbTestMode.Size = new System.Drawing.Size(128, 24);
      this.cbTestMode.TabIndex = 3;
      this.cbTestMode.Text = "Teszt Md";
      // 
      // btnCancel
      // 
      this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnCancel.Location = new System.Drawing.Point(364, 288);
      this.btnCancel.Name = "btnCancel";
      this.btnCancel.TabIndex = 2;
      this.btnCancel.Text = "Mgsem";
      // 
      // btnOK
      // 
      this.btnOK.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnOK.Location = new System.Drawing.Point(284, 288);
      this.btnOK.Name = "btnOK";
      this.btnOK.TabIndex = 2;
      this.btnOK.Text = "Ments";
      // 
      // txtUName
      // 
      this.txtUName.BackColor = System.Drawing.Color.White;
      this.txtUName.Location = new System.Drawing.Point(84, 8);
      this.txtUName.Name = "txtUName";
      this.txtUName.ReadOnly = true;
      this.txtUName.Size = new System.Drawing.Size(180, 20);
      this.txtUName.TabIndex = 0;
      this.txtUName.Text = "";
      // 
      // label3
      // 
      this.label3.Location = new System.Drawing.Point(4, 8);
      this.label3.Name = "label3";
      this.label3.Size = new System.Drawing.Size(76, 23);
      this.label3.TabIndex = 1;
      this.label3.Text = "Nv:";
      this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
      // 
      // btnDelete
      // 
      this.btnDelete.Enabled = false;
      this.btnDelete.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnDelete.Location = new System.Drawing.Point(28, 44);
      this.btnDelete.Name = "btnDelete";
      this.btnDelete.Size = new System.Drawing.Size(216, 24);
      this.btnDelete.TabIndex = 2;
      this.btnDelete.Text = "Trls";
      this.btnDelete.Click += new System.EventHandler(this.btnDelete_Click);
      // 
      // Settings
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(220)), ((System.Byte)(234)), ((System.Byte)(245)));
      this.ClientSize = new System.Drawing.Size(446, 316);
      this.Controls.Add(this.btnCancel);
      this.Controls.Add(this.gbOther);
      this.Controls.Add(this.gbUsers);
      this.Controls.Add(this.btnOK);
      this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
      this.MaximizeBox = false;
      this.MinimizeBox = false;
      this.Name = "Settings";
      this.Text = "Karbantarts";
      this.Load += new System.EventHandler(this.Settings_Load);
      this.gbUsers.ResumeLayout(false);
      this.pnlUserInfo.ResumeLayout(false);
      this.gbOther.ResumeLayout(false);
      ((System.ComponentModel.ISupportInitialize)(this.tbLogL)).EndInit();
      this.pnlLogL.ResumeLayout(false);
      this.ResumeLayout(false);

    }
		#endregion

    private void lbUsers_SelectedIndexChanged(object sender, System.EventArgs e)
    {
      this.txtUName.Text = Users[this.lbUsers.SelectedIndex];
      this.btnDelete.Enabled = true;
    }

    private void Settings_Load(object sender, System.EventArgs e)
    {
      WebHandler wh = new WebHandler(serverpath,server,user,pass,port);
      wh.UserId = UserId;
      wh.LogedIn = true;
      string Ret = wh.PHPGetUsers();
      string UsersOk = Ret.Substring(Ret.IndexOf("ok ret")+7);
      Users = UsersOk.Split('|');
      this.lbUsers.DataSource = Users;
    }

    private void btnDelete_Click(object sender, System.EventArgs e)
    {
      WebHandler wh = new WebHandler(serverpath,server,user,pass,port);
      wh.UserId = UserId;
      wh.LogedIn = true;
      if(wh.PHPValidate(wh.PHPDelUser(this.lbUsers.SelectedIndex.ToString())))
      {
        MessageBox.Show("Trls sikeres!","Informci");
        Users = wh.PHPGetUsers().Split('|');
        this.lbUsers.DataSource = Users;
      }
      else
      {
        MessageBox.Show(wh.LastError,"Hiba");
      }
    }

    private void btnNewUser_Click(object sender, System.EventArgs e)
    {
      NewUser nu = new NewUser();
      nu.cbLevel.DataSource = Enum.GetNames(typeof(TeamServer.Level));
      
      if(nu.ShowDialog() == DialogResult.OK)
      {
        WebHandler wh = new WebHandler(serverpath,server,user,pass,port);
        wh.UserId = UserId;
        wh.LogedIn = true;
        if(wh.PHPValidate(wh.PHPAddUser(nu.txtUser.Text,
                                        nu.txtPass.Text,
                                        nu.txtEMail.Text,
                                        (TeamServer.Level)nu.cbLevel.SelectedIndex)))
        {
          MessageBox.Show("Felhasznl elkszlt!","Informci");
          Users = wh.PHPGetUsers().Split('|');
          this.lbUsers.DataSource = Users;
        }
        else
        {
          MessageBox.Show(wh.LastError,"Hiba");
        }
      }
    }
	}
}
