using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using JadamPrograms.TeamServer;
using System.IO;
using System.Net;
using System.Web;

namespace JadamPrograms.TeamServer
{
	/// <summary>
	/// Summary description for SoftwareInstal.
	/// </summary>
	public class SoftwareInstal : System.Windows.Forms.Form
	{
    private System.Windows.Forms.GroupBox gbMySQL;
    private System.Windows.Forms.Label lblSqlServer;
    private System.Windows.Forms.Label lblSqlUser;
    private System.Windows.Forms.Label lblSqlPass;
    private System.Windows.Forms.Label lblSqlDBName;
    private System.Windows.Forms.TextBox txtSqlServer;
    private System.Windows.Forms.TextBox txtSqlUser;
    private System.Windows.Forms.TextBox txtSqlPass;
    private System.Windows.Forms.TextBox txtSqlDBName;
    private System.Windows.Forms.GroupBox gbAdmin;
    private System.Windows.Forms.ProgressBar progressBar1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

    public string serverpath = ""; 
    public string server     = "";
    public string user       = "";		
    public string pass       = "";	
    public int    port       = 21;
    
    Thread InstallerThread;
    private System.Windows.Forms.Button btnValidateFTP;
    private System.Windows.Forms.Button btnInstall;
    private System.Windows.Forms.Button btnCancel;
    private System.Windows.Forms.Label lblAUser;
    private System.Windows.Forms.Label lblAPass;
    private System.Windows.Forms.TextBox txtAUser;
    private System.Windows.Forms.TextBox txtAPass;
    private System.Windows.Forms.Label lblAEMail;
    private System.Windows.Forms.TextBox txtAEMail;
    
    private string LastError = ""; 
    
    private string DefSQL = "CREATE TABLE `CheckedOutFiles` (`FileName` varchar(200) NOT NULL default '',`Name` varchar(200) NOT NULL,`CheckOutDate` date default NULL,PRIMARY KEY  (`FileName`))";
    private string DefSQL2 = "CREATE TABLE `users` (`Id` int(11) NOT NULL auto_increment,`Username` varchar(200) NOT NULL,`Password` varchar(200) NOT NULL,`EMail` varchar(300) NOT NULL,`Level` varchar(20) NOT NULL,`LoginID` varchar(300) NOT NULL,PRIMARY KEY  (`Id`))";
    private string DefSQL3 = "INSERT INTO `users` (`Username`, `Password`, `EMail`, `Level`) VALUES (";
    private string DefSQL4 = "CREATE TABLE `Messages` (`Id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,`Message` VARCHAR( 500 ) NOT NULL ,`From` VARCHAR( 200 ) NOT NULL ,`To` VARCHAR( 200 ) NOT NULL)";    
    
    private string EndSQL = ", '0');";
    
    FTPLib.FTP ftp; 

		public SoftwareInstal()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			Application.EnableVisualStyles();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		
    #region GetDataFromServer
    
    //
    //PHP-vel adotak kr a szervertol.
    //
    public string GetDataFromServer(string QueryString)
    {
      try
      {
        //MessageBox.Show(QueryString,"Information");
        WebRequest reqest = WebRequest.Create(QueryString);
        WebResponse response = reqest.GetResponse();
        StreamReader sr = new StreamReader(response.GetResponseStream(),System.Text.Encoding.UTF8);
        string read = sr.ReadToEnd();
        reqest.Abort();
        response.Close();
        sr.Close();
        return read;
      }
      catch(System.Exception e)
      {
        LastError = e.Message;
        return "";
      }
    }
    #endregion

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.gbMySQL = new System.Windows.Forms.GroupBox();
      this.txtSqlServer = new System.Windows.Forms.TextBox();
      this.lblSqlServer = new System.Windows.Forms.Label();
      this.lblSqlUser = new System.Windows.Forms.Label();
      this.lblSqlPass = new System.Windows.Forms.Label();
      this.lblSqlDBName = new System.Windows.Forms.Label();
      this.txtSqlUser = new System.Windows.Forms.TextBox();
      this.txtSqlPass = new System.Windows.Forms.TextBox();
      this.txtSqlDBName = new System.Windows.Forms.TextBox();
      this.gbAdmin = new System.Windows.Forms.GroupBox();
      this.lblAUser = new System.Windows.Forms.Label();
      this.lblAPass = new System.Windows.Forms.Label();
      this.txtAUser = new System.Windows.Forms.TextBox();
      this.txtAPass = new System.Windows.Forms.TextBox();
      this.lblAEMail = new System.Windows.Forms.Label();
      this.txtAEMail = new System.Windows.Forms.TextBox();
      this.btnValidateFTP = new System.Windows.Forms.Button();
      this.btnInstall = new System.Windows.Forms.Button();
      this.btnCancel = new System.Windows.Forms.Button();
      this.progressBar1 = new System.Windows.Forms.ProgressBar();
      this.gbMySQL.SuspendLayout();
      this.gbAdmin.SuspendLayout();
      this.SuspendLayout();
      // 
      // gbMySQL
      // 
      this.gbMySQL.Controls.Add(this.txtSqlServer);
      this.gbMySQL.Controls.Add(this.lblSqlServer);
      this.gbMySQL.Controls.Add(this.lblSqlUser);
      this.gbMySQL.Controls.Add(this.lblSqlPass);
      this.gbMySQL.Controls.Add(this.lblSqlDBName);
      this.gbMySQL.Controls.Add(this.txtSqlUser);
      this.gbMySQL.Controls.Add(this.txtSqlPass);
      this.gbMySQL.Controls.Add(this.txtSqlDBName);
      this.gbMySQL.Location = new System.Drawing.Point(8, 8);
      this.gbMySQL.Name = "gbMySQL";
      this.gbMySQL.Size = new System.Drawing.Size(368, 168);
      this.gbMySQL.TabIndex = 0;
      this.gbMySQL.TabStop = false;
      this.gbMySQL.Text = "MySQL  Server adatai";
      // 
      // txtSqlServer
      // 
      this.txtSqlServer.Location = new System.Drawing.Point(128, 24);
      this.txtSqlServer.Name = "txtSqlServer";
      this.txtSqlServer.Size = new System.Drawing.Size(232, 20);
      this.txtSqlServer.TabIndex = 1;
      this.txtSqlServer.Text = "xyz.zyx.sql";
      // 
      // lblSqlServer
      // 
      this.lblSqlServer.Location = new System.Drawing.Point(16, 24);
      this.lblSqlServer.Name = "lblSqlServer";
      this.lblSqlServer.TabIndex = 0;
      this.lblSqlServer.Text = "Szerver cm:";
      // 
      // lblSqlUser
      // 
      this.lblSqlUser.Location = new System.Drawing.Point(16, 56);
      this.lblSqlUser.Name = "lblSqlUser";
      this.lblSqlUser.TabIndex = 0;
      this.lblSqlUser.Text = "Felhasznlnv:";
      // 
      // lblSqlPass
      // 
      this.lblSqlPass.Location = new System.Drawing.Point(16, 88);
      this.lblSqlPass.Name = "lblSqlPass";
      this.lblSqlPass.TabIndex = 0;
      this.lblSqlPass.Text = "Jelsz:";
      // 
      // lblSqlDBName
      // 
      this.lblSqlDBName.Location = new System.Drawing.Point(16, 136);
      this.lblSqlDBName.Name = "lblSqlDBName";
      this.lblSqlDBName.TabIndex = 0;
      this.lblSqlDBName.Text = "Adatbzis nv:";
      // 
      // txtSqlUser
      // 
      this.txtSqlUser.Location = new System.Drawing.Point(128, 56);
      this.txtSqlUser.Name = "txtSqlUser";
      this.txtSqlUser.Size = new System.Drawing.Size(232, 20);
      this.txtSqlUser.TabIndex = 1;
      this.txtSqlUser.Text = "Xyz";
      // 
      // txtSqlPass
      // 
      this.txtSqlPass.Location = new System.Drawing.Point(128, 88);
      this.txtSqlPass.Name = "txtSqlPass";
      this.txtSqlPass.PasswordChar = '*';
      this.txtSqlPass.Size = new System.Drawing.Size(232, 20);
      this.txtSqlPass.TabIndex = 1;
      this.txtSqlPass.Text = "";
      // 
      // txtSqlDBName
      // 
      this.txtSqlDBName.Location = new System.Drawing.Point(128, 136);
      this.txtSqlDBName.Name = "txtSqlDBName";
      this.txtSqlDBName.Size = new System.Drawing.Size(232, 20);
      this.txtSqlDBName.TabIndex = 1;
      this.txtSqlDBName.Text = "XyzDB";
      // 
      // gbAdmin
      // 
      this.gbAdmin.Controls.Add(this.lblAUser);
      this.gbAdmin.Controls.Add(this.lblAPass);
      this.gbAdmin.Controls.Add(this.txtAUser);
      this.gbAdmin.Controls.Add(this.txtAPass);
      this.gbAdmin.Controls.Add(this.lblAEMail);
      this.gbAdmin.Controls.Add(this.txtAEMail);
      this.gbAdmin.Location = new System.Drawing.Point(8, 184);
      this.gbAdmin.Name = "gbAdmin";
      this.gbAdmin.Size = new System.Drawing.Size(368, 120);
      this.gbAdmin.TabIndex = 1;
      this.gbAdmin.TabStop = false;
      this.gbAdmin.Text = "Adminisztrtor Adatai";
      // 
      // lblAUser
      // 
      this.lblAUser.Location = new System.Drawing.Point(16, 24);
      this.lblAUser.Name = "lblAUser";
      this.lblAUser.TabIndex = 3;
      this.lblAUser.Text = "Felhasznlnv:";
      // 
      // lblAPass
      // 
      this.lblAPass.Location = new System.Drawing.Point(16, 56);
      this.lblAPass.Name = "lblAPass";
      this.lblAPass.TabIndex = 2;
      this.lblAPass.Text = "Jelsz:";
      // 
      // txtAUser
      // 
      this.txtAUser.Location = new System.Drawing.Point(128, 24);
      this.txtAUser.Name = "txtAUser";
      this.txtAUser.Size = new System.Drawing.Size(232, 20);
      this.txtAUser.TabIndex = 5;
      this.txtAUser.Text = "Xyz";
      // 
      // txtAPass
      // 
      this.txtAPass.Location = new System.Drawing.Point(128, 56);
      this.txtAPass.Name = "txtAPass";
      this.txtAPass.PasswordChar = '*';
      this.txtAPass.Size = new System.Drawing.Size(232, 20);
      this.txtAPass.TabIndex = 4;
      this.txtAPass.Text = "";
      // 
      // lblAEMail
      // 
      this.lblAEMail.Location = new System.Drawing.Point(16, 88);
      this.lblAEMail.Name = "lblAEMail";
      this.lblAEMail.TabIndex = 2;
      this.lblAEMail.Text = "E-Mail:";
      // 
      // txtAEMail
      // 
      this.txtAEMail.Location = new System.Drawing.Point(128, 88);
      this.txtAEMail.Name = "txtAEMail";
      this.txtAEMail.Size = new System.Drawing.Size(232, 20);
      this.txtAEMail.TabIndex = 4;
      this.txtAEMail.Text = "";
      // 
      // btnValidateFTP
      // 
      this.btnValidateFTP.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnValidateFTP.Location = new System.Drawing.Point(8, 336);
      this.btnValidateFTP.Name = "btnValidateFTP";
      this.btnValidateFTP.Size = new System.Drawing.Size(368, 23);
      this.btnValidateFTP.TabIndex = 2;
      this.btnValidateFTP.Text = "FTP Kapcsolat ellenrzse";
      this.btnValidateFTP.Click += new System.EventHandler(this.button1_Click);
      // 
      // btnInstall
      // 
      this.btnInstall.Enabled = false;
      this.btnInstall.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnInstall.Location = new System.Drawing.Point(8, 364);
      this.btnInstall.Name = "btnInstall";
      this.btnInstall.Size = new System.Drawing.Size(280, 23);
      this.btnInstall.TabIndex = 2;
      this.btnInstall.Text = "Telepts";
      this.btnInstall.Click += new System.EventHandler(this.btnInstall_Click);
      // 
      // btnCancel
      // 
      this.btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnCancel.Location = new System.Drawing.Point(296, 364);
      this.btnCancel.Name = "btnCancel";
      this.btnCancel.Size = new System.Drawing.Size(80, 23);
      this.btnCancel.TabIndex = 2;
      this.btnCancel.Text = "Mgsem";
      this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
      // 
      // progressBar1
      // 
      this.progressBar1.Location = new System.Drawing.Point(8, 308);
      this.progressBar1.Name = "progressBar1";
      this.progressBar1.Size = new System.Drawing.Size(368, 23);
      this.progressBar1.TabIndex = 3;
      // 
      // SoftwareInstal
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(220)), ((System.Byte)(234)), ((System.Byte)(245)));
      this.ClientSize = new System.Drawing.Size(382, 392);
      this.ControlBox = false;
      this.Controls.Add(this.progressBar1);
      this.Controls.Add(this.btnValidateFTP);
      this.Controls.Add(this.gbAdmin);
      this.Controls.Add(this.gbMySQL);
      this.Controls.Add(this.btnInstall);
      this.Controls.Add(this.btnCancel);
      this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
      this.Name = "SoftwareInstal";
      this.Text = "JAP Team Server Software teleptse...";
      this.Load += new System.EventHandler(this.SoftwareInstal_Load);
      this.gbMySQL.ResumeLayout(false);
      this.gbAdmin.ResumeLayout(false);
      this.ResumeLayout(false);

    }
		#endregion

    private void SoftwareInstal_Load(object sender, System.EventArgs e)
    {
    }

    private void button1_Click(object sender, System.EventArgs e)
    {
      if(server     != ""   &&
         user       != ""   &&
         pass       != ""   &&
         serverpath != "")
      {
        ftp = new FTPLib.FTP(server,port,user,pass);
        try
        {
          ftp.Connect();
          ftp.Disconnect();
          this.btnValidateFTP.Enabled = false;
          this.btnInstall.Enabled = true;
        }
        catch
        {
          MessageBox.Show("Nem sikerlt kapcsoldni az FTP Serverhez!","Hiba");
        }                    
      }
      else
      {
        MessageBox.Show("Hinyz FTP Adatok!","Hiba");
      } 
    }
    
    private void Install()
    {
      try
      {
        if(this.txtSqlServer.Text != "" &&
           this.txtSqlUser.Text   != "" &&
           this.txtSqlPass.Text   != "" &&
           this.txtSqlDBName.Text != "" &&
           this.txtAUser.Text     != "" &&
           this.txtAPass.Text     != "" &&
           this.txtAEMail.Text    != "")
        {
          ftp = new FTPLib.FTP();
          ftp.server = server;
          ftp.user = user;
          ftp.pass = pass;
          ftp.port = port;
          ftp.Connect();
          this.progressBar1.Value = 10;
          this.Refresh();
        
          try
          {
            ftp.ChangeDir("/wwwroot");
           // MessageBox.Show("wwwroot ChangeDir sikeres!","Hiba");
            try
            {
              ftp.ChangeDir("/wwwroot/Files");
             // MessageBox.Show("wwwroot/Files ChangeDir sikeres!","Hiba");
            }
            catch
            {
              try
              {
                ftp.MakeDir("Files");
               // MessageBox.Show("MakeDir files sikeres!","Hiba");
              }
              catch
              {}
            }
            ftp.ChangeDir("/wwwroot");
          }
          catch
          {          
            ftp.MakeDir("wwwroot");
            ftp.ChangeDir("/wwwroot");
            ftp.MakeDir("Files");
            ftp.ChangeDir("/wwwroot");
          }
          this.progressBar1.Value = 20;
          this.Refresh();
        
          ftp.OpenUpload(Application.StartupPath + @"\Software\teamserv.php","teamserv.php");
          while(ftp.DoUpload() > 0)
          {
            //perc = (int)(((ftp.BytesTotal) * 100) / ftp.FileSize);
          }
          this.progressBar1.Value = 40;
          this.Refresh(); 

          ftp.OpenUpload(Application.StartupPath + @"\Software\InstallSQL.php","InstallSQL.php");
          while(ftp.DoUpload() > 0)
          {
            //perc = (int)(((ftp.BytesTotal) * 100) / ftp.FileSize);
          }
          this.progressBar1.Value = 60;
          this.Refresh();
        
          FileStream fs = new FileStream(Application.StartupPath + @"\Software\DatabaseInfo.php",
                                         FileMode.Create);
                                       
          StreamWriter sw = new StreamWriter(fs);
          sw.WriteLine("<?php");
          sw.WriteLine("$database[\"server\"] = \""   + this.txtSqlServer.Text + "\";");
          sw.WriteLine("$database[\"user\"] = \""     + this.txtSqlUser.Text   + "\";");
          sw.WriteLine("$database[\"password\"] = \"" + this.txtSqlPass.Text   + "\";");
          sw.WriteLine("$database[\"database\"] = \"" + this.txtSqlDBName.Text + "\";");
          sw.WriteLine("$database[\"SQLToInstall\"] = \""
                       + DefSQL 
                       + "\";");
          sw.WriteLine("$database[\"SQLToInstall2\"] = \""
                       + DefSQL2 
                       + "\";");  
          sw.WriteLine("$database[\"SQLToInstall3\"] = \""
                       + DefSQL3
                       + "'" 
                       + this.txtAUser.Text 
                       + "', '" 
                       + this.txtAPass.Text 
                       + "', '" 
                       + this.txtAEMail.Text 
                       + "'" 
                       + EndSQL   
                       + "\";"); 
          sw.WriteLine("$database[\"SQLToInstall4\"] = \""
                       + DefSQL4     
                       + "\";");                                        
          sw.WriteLine("?>");        
          sw.Close();
          fs.Close();
          this.progressBar1.Value = 70;
          this.Refresh();
        
          ftp.OpenUpload(Application.StartupPath + @"\Software\DatabaseInfo.php","databaseinfo.php");
          while(ftp.DoUpload() > 0)
          {
            //perc = (int)(((ftp.BytesTotal) * 100) / ftp.FileSize);
          }
          this.progressBar1.Value = 80;
          this.Refresh();
        
          string Ret = GetDataFromServer(serverpath + "/InstallSQL.php");
          if(Ret.IndexOf("ok ret") != -1)
          {
            this.progressBar1.Value = 90;
            this.Refresh();
          
            ftp.RemoveFile("InstallSQL.php");
            this.progressBar1.Value = 95;
            this.Refresh();
          
            ftp.Disconnect();
            this.progressBar1.Value = 100;
            this.Refresh();
          
            MessageBox.Show("A telepts sikeres!!!","Informci");
          
            this.DialogResult = DialogResult.OK;
            this.Close();
          }
          else
          {
            WebHandler wh = new WebHandler("","","","",0);
            MessageBox.Show("Az adatbzist nem sikerlt ltrehozni!\nHiba:" + wh.GetErrorMsg(Ret),"Hiba");
            MessageBox.Show(Ret);
          }                                                 
        }
        else
        {
          MessageBox.Show("A teleptshez tltse ki a formot!","Hiba");
        }
      }
      catch(System.Exception e)
      {
        MessageBox.Show("A telepts sikertelen!!\nHiba:" + e.Message,"Hiba");
        ftp.Disconnect();
      }
    }

    private void btnInstall_Click(object sender, System.EventArgs e)
    {
      InstallerThread = new Thread(new ThreadStart(Install));
      InstallerThread.Start();
    }

    private void btnCancel_Click(object sender, System.EventArgs e)
    {
      if(InstallerThread != null)
      {
        InstallerThread.Abort();
      }
      
      this.DialogResult = DialogResult.Cancel;
      this.Close();
    }
	}
}
